/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import {
    PersonDto,
    PersonDtoFromJSON,
    PersonDtoToJSON,
} from '../models';

export interface AddPersonRequest {
    personDto: PersonDto;
}

/**
 * no description
 */
export class PersonControllerApi extends runtime.BaseAPI {

    /**
     */
    async addPersonRaw(requestParameters: AddPersonRequest): Promise<runtime.ApiResponse<void>> {
        if (requestParameters.personDto === null || requestParameters.personDto === undefined) {
            throw new runtime.RequiredError('personDto','Required parameter requestParameters.personDto was null or undefined when calling addPerson.');
        }

        const queryParameters: runtime.HTTPQuery = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/api/person`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: PersonDtoToJSON(requestParameters.personDto),
        });

        return new runtime.VoidApiResponse(response);
    }

    /**
     */
    async addPerson(requestParameters: AddPersonRequest): Promise<void> {
        await this.addPersonRaw(requestParameters);
    }

    /**
     */
    async getPersonRaw(): Promise<runtime.ApiResponse<PersonDto>> {
        const queryParameters: runtime.HTTPQuery = {};

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/api/person`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        });

        return new runtime.JSONApiResponse(response, (jsonValue) => PersonDtoFromJSON(jsonValue));
    }

    /**
     */
    async getPerson(): Promise<PersonDto> {
        const response = await this.getPersonRaw();
        return await response.value();
    }

}
